stages:
  - Scan Security
  - Test Code
  - Build Image
  - Deploy Stage

sast:
  stage: Scan Security
include:
  - template: Security/SAST.gitlab-ci.yml
  
Test Unit:
  stage: Test Code
  image: node:20-alpine3.17
  script:
    - echo Testeando el codigo
    - npm install
    - npm run coverage
    - npm run build 

Build Artefact:
  stage: Build Image
  image: docker:20.10.10  
  services:
    - docker:dind
    - name: docker:dind
      alias: dockerhost 
  variables:
    DOCKER_HOST: tcp://dockerhost:2375/
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  before_script:
    - export BUILD_VERSION=$(cat package.json | grep \"version\" | cut -d "\"" -f4)  
  script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    - docker build -t $CI_REGISTRY_IMAGE:latest -t $CI_REGISTRY_IMAGE:$BUILD_VERSION  .
    - docker push $CI_REGISTRY_IMAGE -a 

Deploy Stage:
  stage: Deploy Stage 
  script:
    - echo Desplegando el artefacto desde el docker repository 
    - echo Listo! 